<?php


namespace Toogas\Easypay\Api\Data;

interface EasypayPaymentInterface extends \Magento\Framework\Api\ExtensibleDataInterface
{

    const PAYMENT_ID = 'payment_id';
    const STATUS = 'status';
    const METHOD = 'method';
    const UPDATED_AT = 'updated_at';
    const TYPE = 'type';
    const EASYPAYPAYMENT_ID = 'easypaypayment_id';
    const CREATED_AT = 'created_at';
    const ORDER_ID = 'order_id';

    /**
     * Get easypaypayment_id
     * @return string|null
     */
    public function getEasypaypaymentId();

    /**
     * Set easypaypayment_id
     * @param string $easypaypaymentId
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setEasypaypaymentId($easypaypaymentId);

    /**
     * Get order_id
     * @return string|null
     */
    public function getOrderId();

    /**
     * Set order_id
     * @param string $orderId
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setOrderId($orderId);

    /**
     * Retrieve existing extension attributes object or create a new one.
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentExtensionInterface|null
     */
    public function getExtensionAttributes();

    /**
     * Set an extension attributes object.
     * @param \Toogas\Easypay\Api\Data\EasypayPaymentExtensionInterface $extensionAttributes
     * @return $this
     */
    public function setExtensionAttributes(
        \Toogas\Easypay\Api\Data\EasypayPaymentExtensionInterface $extensionAttributes
    );

    /**
     * Get payment_id
     * @return string|null
     */
    public function getPaymentId();

    /**
     * Set payment_id
     * @param string $paymentId
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setPaymentId($paymentId);

    /**
     * Get type
     * @return string|null
     */
    public function getType();

    /**
     * Set type
     * @param string $type
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setType($type);

    /**
     * Get method
     * @return string|null
     */
    public function getMethod();

    /**
     * Set method
     * @param string $method
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setMethod($method);

    /**
     * Get status
     * @return string|null
     */
    public function getStatus();

    /**
     * Set status
     * @param string $status
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setStatus($status);

    /**
     * Get created_at
     * @return string|null
     */
    public function getCreatedAt();

    /**
     * Set created_at
     * @param string $createdAt
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setCreatedAt($createdAt);

    /**
     * Get updated_at
     * @return string|null
     */
    public function getUpdatedAt();

    /**
     * Set updated_at
     * @param string $updatedAt
     * @return \Toogas\Easypay\Api\Data\EasypayPaymentInterface
     */
    public function setUpdatedAt($updatedAt);
}
